<?php
############################################################################
#
#   Project:    World Weather Extremes
#   Module:     worldextremes.php
#   Purpose:    Provides World Weather Extremes for Web page display
#   Authors:    Michael (michael@relayweather.com)
#   Source:			Data Compiled and Provided by ogimet.com
############################################################################
############################################################################
// version
//error_reporting(E_ALL);
//ini_set('display_errors', 1); 

$extremeGadgetversion = "0.4";
echo "<!-- Start World Weather Extremes Gadget Script Version $extremeGadgetversion -->\n";

/////////////////////////////////////////////////////////////////////////////
//SETTINGS START HERE////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// Select Country or Location
// Examples: "World" = world, "United+S" = United States, "Cana" = Canada, "United+K" = United Kingdom
$GadgetCountry = "United+S"; //Go here (http://www.ogimet.com/ranking.phtml.en), select your country and look in the URL for the country abbr.
// Name of cache file  --  This file must be set to CHMOD-666
$GadgetSiteCache = "worldextremesGadgetCache.php";  
// Age of cache file before re-fetch caching time, in seconds (3600 = 1 hour)
$GadgetCache_life = '2700';
// Select Unit Type
$GadgetUseUnits = 'E';        // 'E'=USA(English) or 'M'=Metric 

//  Add stations that you never want to display
//  example - to skip station ID 91212    $skip1 = "91212";  or leave blank $skip1 = "";
$skip1 = "91765";  // ID of station that will not be reported (Pago Pago - Pacific)
$skip2 = "91375";  // ID of station that will not be reported (Marshall Islands - Pacific)
$skip3 = "91212";  // ID of station that will not be reported (Guam - Pacific)
$skip4 = "91182";  // ID of station that will not be reported (Honolulu - Pacific)
$skip5 = "89108";  // ID of station that will not be reported (Henry - Antarctica)
$skip6 = "91245";  // ID of station that will not be reported (Wake Island - Pacific)
$skip7 = "70174";  // ID of station that will not be reported (Bettles - Alaska)
$skip8 = "70267";  // ID of station that will not be reported (ALLEN ARMY AIRFIELD - Alaska)
$skip9 = "70261";  // ID of station that will not be reported (Fairbanks - Alaska)
$skip10 = "70271";  // ID of station that will not be reported (Gulkana Airport - Alaska)
$skip11 = "89329";  // ID of station that will not be reported (Harry Univ of Wi - Antarctica)
$skip12 = "";  // ID of station that will not be reported (Station Name)
$skip13 = "";  // ID of station that will not be reported (Station Name)
$skip14 = "";  // ID of station that will not be reported (Station Name)
$skip15 = "";  // ID of station that will not be reported (Station Name)

/////////////////////////////////////////////////////////////////////////////
//END SETTINGS///////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

$GadgetYear = gmdate("Y");
$GadgetMonth = gmdate("m");
$GadgetDay = gmdate("d");
$GadgetHour = gmdate("G");
// Site to Parse
$GadgetSiteSource = "http://www.ogimet.com/cgi-bin/gsynext?lang=en&state=$GadgetCountry&rank=10&ano=$GadgetYear&mes=$GadgetMonth&day=$GadgetDay&hora=$GadgetHour&Send=send";
$GadgetSiteURL = str_replace("&", "&amp;", $GadgetSiteSource);
// array of skipped location ID numbers
$skiplocation = array($skip1,$skip2,$skip3,$skip4,$skip5,$skip6,$skip7,$skip8,$skip9,$skip10,$skip11,$skip12,$skip13,$skip14,$skip15);
// narrow down the skipped location array
foreach($skiplocation as $lkey => $locs) {
  if (empty($locs)) {
    unset($skiplocation["$lkey"]);
  }	
}
// sort the skipped location array
sort($skiplocation);
// count the skipped locations
$skipCount = count($skiplocation); 
echo "<!-- Number of desired skipped locations: $skipCount -->\n"; 
// if the cache file exists, get the file time and size 
if (file_exists($GadgetSiteCache)) {
    $filemtime = filemtime($GadgetSiteCache);
    $filesize = filesize($GadgetSiteCache);
    if (0 == $filesize){
        $filemtime = 0;
    }
} else {
    $filemtime = 0;
}   
// check cache file age and write the new data.
$updateCache = '';
$errorRep = '<td align="center">&nbsp;</td>';
$current_time = time();
$cache_age = $current_time - $filemtime;
$tLeft = $GadgetCache_life - $cache_age;
if($tLeft < 0){$tLeft = 0;} // display negative time left as 0 
if($cache_age >= $GadgetCache_life){
   $updateCache = 1;
   $GadgetSitehtml = implode(' ', file($GadgetSiteSource)); 
   if(preg_match("/OGIMET is overloaded/Uis", $GadgetSitehtml)) {
     $updateCache = '';
	 $errorRep = '<td align="center"><span style="color: yellow;">-</span></td>';
     echo "<!-- The source OGIMET is overloaded and cache file was not updated -->\n"; 
   }
}
if ($updateCache){ // re-write cache file if source has data
   $Gadgetmh = fopen($GadgetSiteCache, 'w');
   fwrite($Gadgetmh, $GadgetSitehtml);
   fclose($Gadgetmh);
   echo "<!-- The cache file expired and fresh data written -->\n";
}   
else { // open cache file and read it if not expired or source overloaded
   echo "<!-- The cache life of $GadgetCache_life seconds is valid and expires in $tLeft seconds -->\n";
   $Gadgetmth = fopen($GadgetSiteCache, "r");
   $filesize = filesize($GadgetSiteCache);
   $GadgetSitehtml = fread($Gadgetmth, $filesize);
   fclose($Gadgetmth);
}
 
// Start Unit Conversion if Needed
if($GadgetUseUnits == 'E') {
	function CtoF_Gadget($fixtemp) { // convert C to F
	  return(number_format(((1.8 * $fixtemp) + 32.0) , 1, '.', '') . "&deg; F");
	}
	function MMtoINCHESGadget($fixrain){
	  return (number_format(($fixrain * .0393700787), 2, '.', '') . " in");
	}
}
else {  // leave as C
   function CtoF_Gadget($fixtemp) {
     return ($fixtemp * 1.0) . "&deg; C";
  }
   function MMtoINCHESGadget($fixrain) {
     return ($fixrain * 1.0) . " mm"; // leave in mm
  } 
}	 

//Finds Extremes
//grab the tables from the cache file
preg_match_all('|<table bgcolor="#FFFFDD" align="center">(.*)</table>|Uis', $GadgetSitehtml, $GadgetExtremes);

// sort the extremes
sort_Locs($GadgetExtremes[1][0], $skiplocation, "high temp");
$hiTempLoc = $eLoc;
$hiTempVal = $eVal;
$hiTempDsc = $eLnk;

sort_Locs($GadgetExtremes[1][1], $skiplocation, "low temp");
$loTempLoc = $eLoc;
$loTempVal = $eVal;
$loTempDsc = $eLnk;

sort_Locs($GadgetExtremes[1][2], $skiplocation, "precip");
$hiPrecipLoc = $eLoc;
$hiPrecipVal = $eVal;
$hiPrecipDsc = $eLnk;

?>
<table cellspacing="0" cellpadding="0" border="0" width="100" style="margin: 0px auto 0px auto;">
 <tr>
  <td align="center"><span style="font-size: 70%; color: black;"><a href="<?php echo $GadgetSiteURL ?>" title="  View the top 10 at OGIMET" style="color: black; text-decoration: none">Past 24 hours</a></span></td>
 </tr>
 <tr>
  <td align="center">&nbsp;</td>
 </tr>
 <tr>
  <td align="center"><span style="font-size: 90%; font-weight:bold; color: red;">High Temp</span></td>
 </tr>
 <tr>
  <td align="center"><span style="font-size: 80%; color: black;"><?php print short_longDesc($hiTempLoc,$hiTempDsc); ?></span></td>
 </tr>
 <tr>
  <td align="center"><span style="font-size: 80%; color: red;"><?php echo CtoF_Gadget($hiTempVal); ?></span></td>
 </tr>
 <tr>
  <?php echo  $errorRep; ?>
  
 </tr>
 <tr>
  <td align="center"><span style="font-size: 90%; font-weight:bold; color: blue;">Low Temp</span></td>
 </tr>
 <tr>
  <td align="center"><span style="font-size: 80%; color: black;"><?php print short_longDesc($loTempLoc,$loTempDsc); ?></span></td>
 </tr>
 <tr>
  <td align="center"><span style="font-size: 80%; color: blue;"><?php echo CtoF_Gadget($loTempVal); ?></span></td>
 </tr>
 <tr>
  <?php echo  $errorRep; ?>
  
 </tr>
 <tr>
  <td align="center"><span style="font-size: 90%; font-weight:bold; color: green;">Precipitation</span></td>
 </tr>
 <tr>
  <td align="center"><span style="font-size: 80%; color: black;"><?php print short_longDesc($hiPrecipLoc,$hiPrecipDsc); ?></span></td>
 </tr>
 <tr>
  <td align="center"><span style="font-size: 80%; color: green;"><?php echo MMtoINCHESGadget($hiPrecipVal); ?></span></td>
 </tr>
</table>
<!-- End of World Weather Extremes Gadget -->
<?php 

// sort the data function
function sort_Locs($ge, $skip, $type) {
  global $eLoc, $eVal, $eExt, $foundSkip, $eLnk;
//  $foundSkip = '';
  $newstr = preg_replace("|<caption>.*</caption>|Uis", '', $ge);// get rid of the captions
  $ex1 = explode("</td></tr>", $newstr);  // split up the table into array	
  array_pop($ex1);  // remove the last non-data element off the end of array

  // get the data
  foreach($ex1 as $HIval) {	
    $HIval = preg_replace('|\(.*\)|', '', $HIval);          // remove "(" and ")" and everything inbetween 
	
    preg_match('|<a href.*>(.*)</a>|Uis', $HIval, $exLoc2); // get the location
    $exLoc3a[] = $exLoc2[1];                                // create a full description of the location
  //  $exLoc2[1] = preg_replace('|, .*|', '', $exLoc2[1]);    // get rid of everything in location after comma
  //	$exLoc2[1] = preg_replace('|.*, |', '', $exLoc2[1]);    // get rid of everything in location before comma
    $exLoc3[] = $exLoc2[1];
	
	// put locations into an array
    preg_match('|<b>(.*) .*</b>|Uis', $HIval, $exValue2);   // get the value
    $exValue3[] = $exValue2[1];                             // put values into an array
  
    preg_match("|en&ind=(.*)&ano|Uis", $HIval, $exID2);     // get the ID
    $exID3[] = $exID2[1];                                   // put the ID's into an array
  
  }
  // check for skipped locations
  if(isset($skip[0])) {
    foreach($skip as $key => $val) {
      $slf = array_search($val, $exID3);     // check the skipped location in the ID array
      if(isset($exID3["$slf"])) {            // if an ID matches a skipped location
        echo "<!-- Reporting ".$type." location skipped: ".$exLoc3["$slf"]."-->\n";
	    unset($exLoc3["$slf"]);              // remove the skipped array key in the location array
	    unset($exValue3["$slf"]);            // remove the skipped array key in the value array
	    unset($exID3["$slf"]);               // remove the skipped array key in the ID array
	    unset($exLoc3a["$slf"]);             // remove the skipped array key in the long location array
	  }
    }
  }
  
  $eLoc = array_shift($exLoc3);    // the first key from the location array
  $eVal = array_shift($exValue3);  // the first key from the value array
  $eExt = array_shift($exID3);     // the first key from the ID array
  $eLnk = array_shift($exLoc3a);   // the first key from the long location array
}
  
// use long location on mouseover
function short_longDesc($svl,$lvl) {
  $nvl = '<a style="color: black; text-decoration: none; cursor: pointer" title="'.$lvl.'">'.$svl.'</a>';
  return $nvl;
}
// end of function
?>
